;ASSEMBLED WITH MASM6
;For a clear explanation of the working of the program: see the end 
;of the listing.

seg_a           segment byte public
		assume  cs:seg_a, ds:seg_a, ss:stack_seg_c

parameter       equ 05dh

		org 0h

program         proc far
;DeviceHeader:
nextdev         dd 0ffffffffh
devatt          dw 08000h
		dw offset strategy
		dw offset commands
		db 'SETVERM',0ffh

;Variables
requestl        dw 0h                           ;This is the storage adress of the device request data
requesth        dw 0h
check           db 0h           
result          dw 05h                      ;This word keeps the former found dos-version. If SETVERM was not able to find out the dosversion it returns this. This is usefull for some MSDOS commands, who check both secretly and plainly for the dosversion.
						;The plain one can be detected, which is the same as the secret one of course. Therefore you need to run the application two times to let it run.

;Int 21h entry
compare:        cmp ah,30h                      ;Int 21h ah=fn 30h is the "What version of dos are you?" request.
		jz Save_reg
		cmp ax,3306h                    ;Int 21h ax=fn 3306 is the superceding function above ah=fn 30h. Really though programms check this function as well. Version is loaded in BX.
		jz Alt_method
		cmp ax,4452h                    ;DrDos has it's own system. Returning: ax 1067 for DrDOS 6.
		jz DrDOS                        ;NovellDos (This is a DrDOS version!): ax 1072
						;Can anybody write me something about the returns of this function by a earlier version of DrDos? Thanks!
jmp_old_int:          
		db 0eah                         ;Actually this says JMP FAR Old-Int-21h
oint21l         dw 0000h
oint21h         dw 0000h      

Alt_method:
		mov bx,cs:result
		iret

DrDos:          mov ax,1067h                    ;NovellDos Users should change 1067 into 1072 to avoid erroring up their beautifull system.
		mov dl,0h
		iret

Save_reg:             
		cmp cs:check,10h                ;When check is set 10h SETVERM has called int 21h fn30h itself. It should be handled by dos instead of by itself. This is to find out the true dosversion.
		jz jmp_old_int
		mov byte ptr cs:check,10h       ;Put check to 10h
		int 21h                         ;Get official version.
		mov byte ptr cs:check,0h        ;After this it should be put to zero again.
		push ax                         ;Save processor register
		push dx
		push ds
		push bp

		mov dx,ax                       ;dx contains the official dos version.

		mov bp,sp
		mov bx,[bp+08h]                 ;The stack contains the return-adress of the calling program. On that point lays the code checking for the Dos-version. SETVERM takes advatage of this to find out the DOSVERSION. This is its main taktic.
		mov ax,[bp+0ah]                 ;This adress is rather high on the stack because of all those register pushes.
		mov ds,ax                       ;ds will contain the segment of the calling program. bx the offset adress.
		mov cx,[bx]                     ;We will save the probably checking caller's code into the processor registers.
		inc bx                          ;cx contains the first word of caller-code
		inc bx
		mov ax,[bx]                     ;ax contains the second word of caller-code.
		inc bx
		inc bx
		mov bp,[bx]                     ;bp the third.               
		inc bx
		inc bx
		mov bx,[bx]                     ;bp the fourth. Notice bx has changed it's function. Some registers will change it's funcion from now on. Try to keep track of this.
Pos1:           cmp cl,3dh                      ;SETVERM starts checking: possiblity 1. the callers code is: 'cmp ax,dosversion'.
		jnz Pos2
		cmp ah,75h                      ;The code right herafter: Is the code 'jz/jnz jump_anywhere' or 'jb/jg/jb/etc jump_anywhere'
		ja Pos1b                        ;All the cases who arent jz/jnz, jump to possibility 1b.
		cmp ah,74h
		jb Pos1b
		mov ah,al
		mov al,ch
		jmp ready
Pos2:           cmp cl,03ch                     ;Possiblity 2: 'cmp al,dosversion'
		jnz Pos3       
		cmp al,75h                      ;jz/jnz ?
		ja Pos2b
		cmp al,74h       
		jb Pos2b
		mov al,ch
		mov ah,dh
		jmp ready
Pos3:           cmp cl,83h                      ;Possibility: 'cmp ax,dosversion' (only for the lower byte.).
		jnz Pos4
		cmp ch,0f8h
		jnz Pos6
		cmp ah,75h                      ;jz/jnz ?
		ja Pos3b
		cmp ah,74h
		jb Pos3b
		mov ah,dh
		jmp ready
Pos4:           cmp cx,0e086h                   ;Possibility 4: 'xchg ah,al' followed by a higher/lower comparison
		jz go_on
		cmp cx,0c486h                   ;'xchg ah,al' as well.
		jnz Pos5
go_on:          mov cx,ax
		mov ax,bp
		xchg ch,al
		jmp Pos1
Pos5:           cmp bh,al                       ;Possibility 5: Between the comparison code and the place of checking is some code. Remove it by scrolling up the bytes one by one. 
		jz Pos7                         ;I see everything has scrolled enough to stop trying this method.
		mov cl,ch
		mov ch,al
		mov al,ah
		push cx
		mov cx,bp
		mov ah,cl
		mov cl,ch
		mov ch,bl
		mov bp,cx                       ;bp has no bl and bh so we need a trick to acces it's two bytes.
		pop cx
		mov bl,bh
		jmp Pos1                        ;Ok try everything again.
Pos1b:          mov ah,ch                       ;This is the jb/ja case.
		xchg dl,dh                      ;Compare the minimal requested version with the official version.
		cmp ax,dx                       ;When the official version is higher: return that value.
		jb Pos6
		xchg al,ah
		jmp ready
Pos2b:          cmp ch,dl                       ;The same as 1b
		jb Pos6
		mov al,ch
		mov ah,dh
		jmp ready
Pos3b:          cmp al,dl                       ;The same as 1b
		jb Pos6
		mov ah,dh
		jmp ready
Pos6:           pop bp                          ;Possibility 6: the comparisons turn out that the official version is ok to report.
		pop ds
		pop dx
		pop ax
		mov cx,0h
		mov bx,0h
		iret

Pos7:           mov ax,cs:result                ;Possibility 7: SETVERM is ashamed. Nearly all tricks have failed. This is the last trick.
		mov cs:result,dx             ;'result' keeps the former found dos-version. If SETVERM was not able to find out the dosversion it returns this. This is usefull for some MSDOS commands, who check both secretly and plainly for the dosversion.
		pop bp                          ;The plain one can be detected, which is the same as the secret one of course. Therefore you need to run the application two times to let it run.
		pop ds
		pop dx
		pop bx
		mov cx,0h
		mov bx,0h
		iret

ready:          mov cs:result,ax                ;Save the found version.
		pop bp                          ;We have just the right version. Return happy!
		pop ds
		pop dx
		pop bx                          ;This should be 'pop ax' but this whould erase the found dosversion
		mov cx,0h
		mov bx,0h
pm_end:         iret

;END RESIDENT PART        END RESIDENT PART        END RESIDENT PART        END RESIDENT PART        END RESIDENT PART

strategy:       push ax                         ;This is the first entrypoint when loaded as a device-driver
		mov cs:requestl,bx              ;Save the adress of the device request data.                     
		mov ax,es
		mov cs:requesth,ax
		mov ah,08h                      ;This let SETVERM know it has been started as device-driver
		mov byte ptr [cs:check],ah
		pop ax
		retf

commands:       pushf                           ;This is the second entry point. It should report the lengt of the resident part to DOS.
		push ax
		push bx
		push es
		mov ax,cs:requesth              ;This goes via the request data,.
		mov es,ax
		mov bx,cs:requestl
		mov byte ptr al,es:[bx+2]       ;Is this the installation procedure?
		cmp al,0h       
		jnz finishd                     ;No never mind.
		mov ax,0100h                    ;Report installation was succesfull.
		mov es:[bx+03h],ax              
		mov ax,offset pm_end+5
		mov es:[bx+0eh],ax              ;Report the end of the resident code: offset adress
		mov ax,cs
		mov es:[bx+010h],ax             ;Report the end of the resident code: segmentadres
		jmp install

start::                                         ;This is the very entrypoint when loaded from the prompt or batchfile.
		mov ah,ds:parameter             ;Has it got any parameters containing requestionmarks?
		cmp ah,'?'
		jz info                         ;I guess so. Ok we print out the commercial.
		cmp ah,'h'                      ;All the same for ?,h and H.
		jz info
		cmp ah,'H'
		jz info

install:        mov ax,cs                       ;This is the common part of intalisation. (Both as devicedriver as TSR)
		mov ds,ax
		mov ax,0h                  
		mov es,ax                        
		mov ax,es:280h                  
		cmp ax,0h
		jnz no_install                  ;Someway it shows out SETVERM already has been loaded. Don't load to avoid delaying int21h
		mov ax,1234h                    ;Vector 0a0h is used by checking for this.
		mov [es:280h],ax                ;Save the old int21h into the resident code.
		mov ax,es:84h   
		mov cs:oint21l,ax
		mov ax,es:86h
		mov cs:oint21h,ax
		
		cli
		mov ax,0h                       ;Change the int21h vector to pointing to SETVERM
		mov es,ax
		mov word ptr es:084h,offset compare
		mov ax,cs
		mov word ptr es:086h,ax
		sti

finish:         
		mov ah,09h                      ;Display: succesfully loaded :-) 
		mov dx,offset loaded
		int 21h
		mov ah,cs:check
		cmp ah,08h
		jnz finisht                     ;The ending of the program depends on whether is has started as devicedriver or as a normal program.

finishd:        pop es                          ;End as device driver.
		pop bx
		pop ax
		popf
		retf            

finisht:        mov dx,offset remainder         ;End as TSR
		mov ah,9h                       ;Display: for more info: /?
		int 21h
		mov dx,offset pm_end + 105h     ;The 'keepadress' is counted from the PSP
		int 27h                         ;So not from CS=0, so something like the PSP-lenght should be added. 
		mov ah,4c                       ;Unneccecary security
		int 21h
		ret

no_install:     
		mov ax,0900h                    ;Already loaded. No install. 
		mov dx,offset already_loaded    ;Display: already loaded.
		int 21h
		mov ah,cs:check                 
		cmp ah,08h
		jnz no_installt                 ;The ending of the program depends of whether is has started as devicedriver or as a normal program.  

no_installd:         
		mov ax,cs:requesth
		mov es,ax                       ;Report to dos installation has failed :-(
		mov ax,08103h     
		mov es:[bx+3h],ax
		mov ax,0h
		mov es:[bx+0eh],ax
;                mov es:[bx+10h],ax              
		jmp finishd     
		
no_installt:    
		mov ax,4c00h                    ;Quit. :-(
		int 21h

info:           
		mov ax,cs
		mov es,ax
		mov ax,1301h                    ;Display commercial and quit.
		mov bx,001eh
		mov cx,0796h
		mov dx,1800h
		mov bp,offset commercial
		int 10h

		mov ax,1301h
		mov bx,0007h
		mov cx,0001h
		mov dx,1800h
		mov bp,offset stopcol
		int 10h
		mov ax,4c00h
		int 21h

program         endp

loaded          db 'SETVERM has been loaded succesfully.',0dh,0ah,'$'
already_loaded  db 'SETVERM already has been loaded.',0dh,0ah,'$'
remainder       db 'For more information type SETVERM /?',0dh,0ah,'$'                
stopcol         db ''

commercial      db 'ͻ',0dh,0ah
		db ' Welcome to SETVERM, a new utility to run foreign dos programs.              ',0dh,0ah
		db ' Have you ever noticed the "Incorrect DOS version" error while running one of',0dh,0ah
		db ' your favorite dos applications under a new dos-version? That is very nasty, ',0dh,0ah                
		db ' but here is a good solution: SETVERM!                                       ',0dh,0ah                
		db ' Put it in your CONFIG.SYS or AUTOEXEC.BAT or anywhere you want it to,       ',0dh,0ah                
		db ' and all your problems are gone! It is not requiering any pre-set information',0dh,0ah                
		db ' like the old dos program SETVER. This old program needs to be given the     ',0dh,0ah                
		db ' dos version your application is used to. SETVERM sorts it all out itself.   ',0dh,0ah                
		db ' Additional advantage is the tinyness of the program. (About 130h bytes)     ',0dh,0ah                
		db ' Put it in your CONFIG.SYS like this:                                        ',0dh,0ah                
		db '                                                                             ',0dh,0ah                
		db ' DEVICE=C:\DOS\SETVERM.EXE                                                   ',0dh,0ah   
		db '                                                                             ',0dh,0ah
		db ' OR Put it in your AUTOEXEC.BAT or just type it from the prompt.             ',0dh,0ah                
		db '                                                                             ',0dh,0ah
		db ' If you experience this utility as useful, a small contribution              ',0dh,0ah                
		db ' whould be appreceated greatly. Please sent pm. 5 dollar to:                 ',0dh,0ah                
		db '                                                                             ',0dh,0ah
		db ' MR MIKEL                                                                    ',0dh,0ah 
		db ' Kennedysingel 40                                                            ',0dh,0ah
		db ' 2811 VC Reeuwijk                                                            ',0dh,0ah 
		db ' Holland                                                                     ',0dh,0ah
		db 'ͼ',0dh,0ah
absolut_end     db 0h
		
seg_a           ends


stack_seg_c     segment word stack 'STACK'

		db      100 dup (0)

stack_seg_c     ends

		end     start

;This program takes a sudden tactic to work.
;These lines will explane this tactic.
;
;The program starts with installing the resident part of the program.
;It doesn't matter whether this is a device diver or a TSR.
;It intercepts INT 21h. When INT 21h is called the resident 
;part re-activates. 
;
;It checks for the main DOS function AH= fn 30h. 
;When this is found, it starts to get complicated:
;First the official DOS version is obtained. Using
;service 30h of INT 21h. A trick is neccecary to avoid a loop.
;Then the program tries to find the adress of the calling code.
;The Stack contains the adress INT 21h must IRET back to.
;The program pulls this adress from the stack via bp 'manipulation'.
;Having the adress of the calling piece of program. SETVERM is starting
;to investigate this program piece for the wanted dos-version.
;This piece of callers code could merely be something like this: 
;
;15CE:0100  B4 30        mov     ah,30h    
;15CE:0102  CD 21        int     21h   
;                    
;15CE:0104  3D 06 14     cmp     ax,1406h  ;the stack will contain this adress. (The adress of return.)
;15CE:0107  75 99        jnz     anywhere           
;15CE:0109  12 34 56 78  db      whatever
;
;When this adress obtained. The caller's code is red into the processor-
;registers in this order: CX AX BP BX. This starts just below the INT 21h call.
;(Note the reversal of the high and low bytes.)
;In this case the registers will contain:
;CL 3dh         CH 14h          (CX 133dh) (First line.)
;AL 06h         AH 75h          (AX 7506h) 
;BP 3412h                       (BP can't be split up in two bytes.)
;BL 56h         BH 78h          (BX 7856h)
;
;You see the callers code painly keeps the dosversion it wants to have.
;It is stated in line:
;15CE:0104  3D 06 14     cmp     ax,1406h
;SETVERM returns this one, and the callers code is happy as a child.
;When cl is 3dh, ch and al contain the doscode. These are mov-ed in the
;AX register. AX=1406h (Fn 30h delivers the DOS-version inverted.
;When the dos-version is eg. 6.20, AX would not contain 0614 (14 hex.=20 dec.)
;but is would contain AX=1406h.)
;
;The callers-code has often a differend structure.
;SETVERM cannot blindly take the second and third byte for Dos-version
;Therefore it is necesery the SETVERM checks for differend structures
;indicated by sudden opcodes. The program searches for a opcode linked
;to a comparison command. Other opcodes indicate where a comparison-
;opcode could be found.
;
;This is a example: SETVERM has loaded some bytes.
;The program starts to compare CL with differend opcodes.
;When cl is 86h, the code could be something like this:
;15CE:0143  B4 30        mov     ah,30h
;15CE:0145  CD 21        int     21h  
;                        
;15CE:0147  86 E0        xchg    ah,al
;15CE:0149  3D 14 03     cmp     ax,0314h
;15CE:014B  74 99        jz      anywhere
;
;This proves the use of using more then two register for gaining the DOS-Version.
;When the program encounters this, all bytes are shifted two bytes up
;in the registers. Exchanging byte 15CE:14Ah and 15CE:14Bh. And the
;rest goes like in the beginning.
;
;When CL is doesn't fit to anything, all byte's are shifted up
;one place, and a new comparison is started. (Till 3 / 4 times.)
;Hoping to get rid of inbetween laying code of less importance.
;
;In cases as this code:
;15CE:0109  B4 30        mov     ah,30h
;15CE:010B  CD 21        int     21h       
;                                           
;15CE:010D  3D 12 05     cmp     ax,512h
;15CE:0110  EB 0E        jmp     120
;You see there is made a comparison, but there is no
;verifiation of the result. You may think it is strange,
;but in such cases SETVERM returns the official Dos-Version,
;when the by SETVERM system obtained version is lower than the
;official reported Dos-Version.
;This is done, because in many cases these caller code's structures verify
;the Dos-Version not in exact way (like jz/jnz/je/jne) but in
;a more loose way (like jg/ja/jb/jng, etc.). Indicating there
;is not an exact Dos-Version needed, but a mere indication the program
;will work from Dos-Version x. and higher. So it is better to report the
;highest Dos-Version. It is also better for the program to be given the 
;official version.
;
;Sometimes SETVERM will report a bad Dos-Version, letting the callers-code
;think the Dos-Version is lower as 3.3 or something.
;For example, PC-Tools will report Dos-Version 0.00. Haha! @:-)
;This is because PC-Tools callerscode compares the reported Dos-Version
;with zero. So the program will return version zero.
;Smartdrv.sys (Early versions of DOS 5.0) will report a bad Dos-Version
;for an alike reason. These problems could be solved by installing
;SETVERM first in the CONFIG.SYS, followed by an instructed SETVER.EXE
;provided by DOS.
